from .return_value import Return_value
import json
from subprocess import run, PIPE
from typing import Literal

l_cmdlet_name = Literal[
                        'Add-AppPackage',
                        'Add-AppPackageVolume',
                        'Add-AppProvisionedPackage',
                        'Add-AppvClientConnectionGroup',
                        'Add-AppvClientPackage',
                        'Add-AppvPublishingServer',
                        'Add-AppxPackage',
                        'Add-AppxProvisionedPackage',
                        'Add-AppxVolume',
                        'Add-BCDataCacheExtension',
                        'Add-BitsFile',
                        'Add-CertificateEnrollmentPolicyServer',
                        'Add-ClusteriSCSITargetServerRole',
                        'Add-Computer',
                        'Add-Content',
                        'Add-DnsClientDohServerAddress',
                        'Add-DnsClientNrptRule',
                        'Add-DtcClusterTMMapping',
                        'Add-EtwTraceProvider',
                        'Add-History',
                        'Add-InitiatorIdToMaskingSet',
                        'Add-IscsiVirtualDiskTargetMapping',
                        'Add-JobTrigger',
                        'Add-KdsRootKey',
                        'Add-LocalGroupMember',
                        'Add-Member',
                        'Add-MpPreference',
                        'Add-MpPreference',
                        'Add-NetEventNetworkAdapter',
                        'Add-NetEventPacketCaptureProvider',
                        'Add-NetEventProvider',
                        'Add-NetEventVFPProvider',
                        'Add-NetEventVmNetworkAdapter',
                        'Add-NetEventVmSwitch',
                        'Add-NetEventVmSwitchProvider',
                        'Add-NetEventWFPCaptureProvider',
                        'Add-NetIPHttpsCertBinding',
                        'Add-NetLbfoTeamMember',
                        'Add-NetLbfoTeamNic',
                        'Add-NetNatExternalAddress',
                        'Add-NetNatStaticMapping',
                        'Add-NetSwitchTeamMember',
                        'Add-OdbcDsn',
                        'Add-PartitionAccessPath',
                        'Add-PhysicalDisk',
                        'Add-Printer',
                        'Add-PrinterDriver',
                        'Add-PrinterPort',
                        'Add-ProvisionedAppPackage',
                        'Add-ProvisionedAppxPackage',
                        'Add-PSSnapin',
                        'Add-RDServer',
                        'Add-RDSessionHost',
                        'Add-RDVirtualDesktopToCollection',
                        'Add-SignerRule',
                        'Add-StorageFaultDomain',
                        'Add-TargetPortToMaskingSet',
                        'Add-Type',
                        'Add-VirtualDiskToMaskingSet',
                        'Add-VMDirectVirtualDisk',
                        'Add-VpnConnection',
                        'Add-VpnConnectionRoute',
                        'Add-VpnConnectionTriggerApplication',
                        'Add-VpnConnectionTriggerDnsConfiguration',
                        'Add-VpnConnectionTriggerTrustedNetwork',
                        'Add-WindowsCapability',
                        'Add-WindowsDriver',
                        'Add-WindowsFeature',
                        'Add-WindowsImage',
                        'Add-WindowsPackage',
                        'AfterAll',
                        'AfterEach',
                        'Apply-WindowsUnattend',
                        'Assert-MockCalled',
                        'Assert-VerifiableMocks',
                        'Backup-AuditPolicy',
                        'Backup-SecurityPolicy',
                        'BeforeAll',
                        'BeforeEach',
                        'Block-FileShareAccess',
                        'Block-SmbShareAccess',
                        'Checkpoint-Computer',
                        'Checkpoint-IscsiVirtualDisk',
                        'Clear-BCCache',
                        'Clear-Content',
                        'Clear-Disk',
                        'Clear-DnsClientCache',
                        'Clear-EventLog',
                        'Clear-FileStorageTier',
                        'Clear-History',
                        'Clear-Host',
                        'Clear-Item',
                        'Clear-ItemProperty',
                        'Clear-KdsCache',
                        'Clear-PcsvDeviceLog',
                        'Clear-RecycleBin',
                        'Clear-StorageBusDisk',
                        'Clear-StorageDiagnosticInfo',
                        'Clear-Tpm',
                        'Clear-UevAppxPackage',
                        'Clear-UevConfiguration',
                        'Clear-Variable',
                        'Clear-WindowsCorruptMountPoint',
                        'Close-SmbOpenFile',
                        'Close-SmbSession',
                        'Compare-Object',
                        'Complete-BitsTransfer',
                        'Complete-DtcDiagnosticTransaction',
                        'Complete-Transaction',
                        'Compress-Archive',
                        'Configuration',
                        'Confirm-SecureBootUEFI',
                        'Connect-IscsiTarget',
                        'Connect-PSSession',
                        'Connect-VirtualDisk',
                        'Connect-WSMan',
                        'Context',
                        'Convert-IscsiVirtualDisk',
                        'Convert-Path',
                        'Convert-String',
                        'ConvertFrom-CIPolicy',
                        'ConvertFrom-Csv',
                        'ConvertFrom-Json',
                        'ConvertFrom-SddlString',
                        'ConvertFrom-SecureString',
                        'ConvertFrom-String',
                        'ConvertFrom-StringData',
                        'ConvertTo-Csv',
                        'ConvertTo-Html',
                        'ConvertTo-Json',
                        'ConvertTo-ProcessMitigationPolicy',
                        'ConvertTo-SecureString',
                        'ConvertTo-TpmOwnerAuth',
                        'ConvertTo-Xml',
                        'Copy-Item',
                        'Copy-ItemProperty',
                        'Copy-NetFirewallRule',
                        'Copy-NetIPsecMainModeCryptoSet',
                        'Copy-NetIPsecMainModeRule',
                        'Copy-NetIPsecPhase1AuthSet',
                        'Copy-NetIPsecPhase2AuthSet',
                        'Copy-NetIPsecQuickModeCryptoSet',
                        'Copy-NetIPsecRule',
                        'Debug-FileShare',
                        'Debug-Job',
                        'Debug-MMAppPrelaunch',
                        'Debug-Process',
                        'Debug-Runspace',
                        'Debug-StorageSubSystem',
                        'Debug-Volume',
                        'Delete-DeliveryOptimizationCache',
                        'Describe',
                        'Disable-AppBackgroundTaskDiagnosticLog',
                        'Disable-Appv',
                        'Disable-AppvClientConnectionGroup',
                        'Disable-BC',
                        'Disable-BCDowngrading',
                        'Disable-BCServeOnBattery',
                        'Disable-ComputerRestore',
                        'Disable-DAManualEntryPointSelection',
                        'Disable-DeliveryOptimizationVerboseLogs',
                        'Disable-DscDebug',
                        'Disable-JobTrigger',
                        'Disable-LocalUser',
                        'Disable-MMAgent',
                        'Disable-NetAdapter',
                        'Disable-NetAdapterBinding',
                        'Disable-NetAdapterChecksumOffload',
                        'Disable-NetAdapterEncapsulatedPacketTaskOffload',
                        'Disable-NetAdapterIPsecOffload',
                        'Disable-NetAdapterLso',
                        'Disable-NetAdapterPacketDirect',
                        'Disable-NetAdapterPowerManagement',
                        'Disable-NetAdapterQos',
                        'Disable-NetAdapterRdma',
                        'Disable-NetAdapterRsc',
                        'Disable-NetAdapterRss',
                        'Disable-NetAdapterSriov',
                        'Disable-NetAdapterUso',
                        'Disable-NetAdapterVmq',
                        'Disable-NetDnsTransitionConfiguration',
                        'Disable-NetFirewallRule',
                        'Disable-NetIPHttpsProfile',
                        'Disable-NetIPsecMainModeRule',
                        'Disable-NetIPsecRule',
                        'Disable-NetNatTransitionConfiguration',
                        'Disable-NetworkSwitchEthernetPort',
                        'Disable-NetworkSwitchFeature',
                        'Disable-NetworkSwitchVlan',
                        'Disable-OdbcPerfCounter',
                        'Disable-PhysicalDiskIdentification',
                        'Disable-PhysicalDiskIndication',
                        'Disable-PhysicalDiskIndication',
                        'Disable-PnpDevice',
                        'Disable-PSBreakpoint',
                        'Disable-PSRemoting',
                        'Disable-PSSessionConfiguration',
                        'Disable-PSTrace',
                        'Disable-PSWSManCombinedTrace',
                        'Disable-RDVirtualDesktopADMachineAccountReuse',
                        'Disable-RunspaceDebug',
                        'Disable-ScheduledJob',
                        'Disable-ScheduledTask',
                        'Disable-ServerManagerStandardUserRemoting',
                        'Disable-SmbDelegation',
                        'Disable-StorageBusCache',
                        'Disable-StorageBusDisk',
                        'Disable-StorageDataCollection',
                        'Disable-StorageDiagnosticLog',
                        'Disable-StorageDiagnosticLog',
                        'Disable-StorageEnclosureIdentification',
                        'Disable-StorageEnclosurePower',
                        'Disable-StorageHighAvailability',
                        'Disable-StorageMaintenanceMode',
                        'Disable-TlsCipherSuite',
                        'Disable-TlsEccCurve',
                        'Disable-TlsSessionTicketKey',
                        'Disable-TpmAutoProvisioning',
                        'Disable-Ual',
                        'Disable-Uev',
                        'Disable-UevAppxPackage',
                        'Disable-UevTemplate',
                        'Disable-WdacBidTrace',
                        'Disable-WindowsErrorReporting',
                        'Disable-WindowsOptionalFeature',
                        'Disable-WSManCredSSP',
                        'Disable-WSManTrace',
                        'Disconnect-IscsiTarget',
                        'Disconnect-NfsSession',
                        'Disconnect-PSSession',
                        'Disconnect-RDUser',
                        'Disconnect-VirtualDisk',
                        'Disconnect-WSMan',
                        'Dismount-AppPackageVolume',
                        'Dismount-AppxVolume',
                        'Dismount-DiskImage',
                        'Dismount-IscsiVirtualDiskSnapshot',
                        'Dismount-WindowsImage',
                        'Edit-CIPolicyRule',
                        'Enable-AppBackgroundTaskDiagnosticLog',
                        'Enable-Appv',
                        'Enable-AppvClientConnectionGroup',
                        'Enable-BCDistributed',
                        'Enable-BCDowngrading',
                        'Enable-BCHostedClient',
                        'Enable-BCHostedServer',
                        'Enable-BCLocal',
                        'Enable-BCServeOnBattery',
                        'Enable-ComputerRestore',
                        'Enable-DAManualEntryPointSelection',
                        'Enable-DeliveryOptimizationVerboseLogs',
                        'Enable-DscDebug',
                        'Enable-JobTrigger',
                        'Enable-LocalUser',
                        'Enable-MMAgent',
                        'Enable-NetAdapter',
                        'Enable-NetAdapterBinding',
                        'Enable-NetAdapterChecksumOffload',
                        'Enable-NetAdapterEncapsulatedPacketTaskOffload',
                        'Enable-NetAdapterIPsecOffload',
                        'Enable-NetAdapterLso',
                        'Enable-NetAdapterPacketDirect',
                        'Enable-NetAdapterPowerManagement',
                        'Enable-NetAdapterQos',
                        'Enable-NetAdapterRdma',
                        'Enable-NetAdapterRsc',
                        'Enable-NetAdapterRss',
                        'Enable-NetAdapterSriov',
                        'Enable-NetAdapterUso',
                        'Enable-NetAdapterVmq',
                        'Enable-NetDnsTransitionConfiguration',
                        'Enable-NetFirewallRule',
                        'Enable-NetIPHttpsProfile',
                        'Enable-NetIPsecMainModeRule',
                        'Enable-NetIPsecRule',
                        'Enable-NetNatTransitionConfiguration',
                        'Enable-NetworkSwitchEthernetPort',
                        'Enable-NetworkSwitchFeature',
                        'Enable-NetworkSwitchVlan',
                        'Enable-OdbcPerfCounter',
                        'Enable-PhysicalDiskIdentification',
                        'Enable-PhysicalDiskIndication',
                        'Enable-PhysicalDiskIndication',
                        'Enable-PnpDevice',
                        'Enable-PSBreakpoint',
                        'Enable-PSRemoting',
                        'Enable-PSSessionConfiguration',
                        'Enable-PSTrace',
                        'Enable-PSWSManCombinedTrace',
                        'Enable-RDVirtualDesktopADMachineAccountReuse',
                        'Enable-RunspaceDebug',
                        'Enable-ScheduledJob',
                        'Enable-ScheduledTask',
                        'Enable-ServerManagerStandardUserRemoting',
                        'Enable-SmbDelegation',
                        'Enable-StorageBusCache',
                        'Enable-StorageBusDisk',
                        'Enable-StorageDataCollection',
                        'Enable-StorageDiagnosticLog',
                        'Enable-StorageDiagnosticLog',
                        'Enable-StorageEnclosureIdentification',
                        'Enable-StorageEnclosurePower',
                        'Enable-StorageHighAvailability',
                        'Enable-StorageMaintenanceMode',
                        'Enable-TlsCipherSuite',
                        'Enable-TlsEccCurve',
                        'Enable-TlsSessionTicketKey',
                        'Enable-TpmAutoProvisioning',
                        'Enable-Ual',
                        'Enable-Uev',
                        'Enable-UevAppxPackage',
                        'Enable-UevTemplate',
                        'Enable-WdacBidTrace',
                        'Enable-WindowsErrorReporting',
                        'Enable-WindowsOptionalFeature',
                        'Enable-WSManCredSSP',
                        'Enable-WSManTrace',
                        'Enter-PSHostProcess',
                        'Enter-PSSession',
                        'Exit-PSHostProcess',
                        'Exit-PSSession',
                        'Expand-Archive',
                        'Expand-IscsiVirtualDisk',
                        'Expand-WindowsCustomDataImage',
                        'Expand-WindowsImage',
                        'Export-Alias',
                        'Export-BCCachePackage',
                        'Export-BCSecretKey',
                        'Export-BinaryMiLog',
                        'Export-Certificate',
                        'Export-Clixml',
                        'Export-Console',
                        'Export-Counter',
                        'Export-Csv',
                        'Export-FormatData',
                        'Export-IscsiTargetServerConfiguration',
                        'Export-IscsiVirtualDiskSnapshot',
                        'Export-ModuleMember',
                        'Export-ODataEndpointProxy',
                        'Export-PfxCertificate',
                        'Export-PSSession',
                        'Export-RDPersonalSessionDesktopAssignment',
                        'Export-RDPersonalVirtualDesktopAssignment',
                        'Export-ScheduledTask',
                        'Export-StartLayout',
                        'Export-StartLayoutEdgeAssets',
                        'Export-TlsSessionTicketKey',
                        'Export-UevConfiguration',
                        'Export-UevPackage',
                        'Export-WindowsCapabilitySource',
                        'Export-WindowsDriver',
                        'Export-WindowsImage',
                        'Export-WinhttpProxy',
                        'Find-Command',
                        'Find-DscResource',
                        'Find-Module',
                        'Find-NetIPsecRule',
                        'Find-NetRoute',
                        'Find-Package',
                        'Find-PackageProvider',
                        'Find-RoleCapability',
                        'Find-Script',
                        'Flush-EtwTraceSession',
                        'Flush-Volume',
                        'Flush-Volume',
                        'ForEach-Object',
                        'Format-Custom',
                        'Format-Hex',
                        'Format-List',
                        'Format-SecureBootUEFI',
                        'Format-Table',
                        'Format-Volume',
                        'Format-Wide',
                        'Get-Acl',
                        'Get-Alias',
                        'Get-AppBackgroundTask',
                        'Get-AppLockerFileInformation',
                        'Get-AppLockerPolicy',
                        'Get-AppPackage',
                        'Get-AppPackageDefaultVolume',
                        'Get-AppPackageLastError',
                        'Get-AppPackageLog',
                        'Get-AppPackageManifest',
                        'Get-AppPackageVolume',
                        'Get-AppProvisionedPackage',
                        'Get-AppvClientApplication',
                        'Get-AppvClientConfiguration',
                        'Get-AppvClientConnectionGroup',
                        'Get-AppvClientMode',
                        'Get-AppvClientPackage',
                        'Get-AppvPublishingServer',
                        'Get-AppvStatus',
                        'Get-AppvVirtualProcess',
                        'Get-AppxDefaultVolume',
                        'Get-AppxLastError',
                        'Get-AppxLog',
                        'Get-AppxPackage',
                        'Get-AppxPackageManifest',
                        'Get-AppxProvisionedPackage',
                        'Get-AppxVolume',
                        'Get-AuthenticodeSignature',
                        'Get-AutologgerConfig',
                        'Get-BCClientConfiguration',
                        'Get-BCContentServerConfiguration',
                        'Get-BCDataCache',
                        'Get-BCDataCacheExtension',
                        'Get-BCHashCache',
                        'Get-BCHostedCacheServerConfiguration',
                        'Get-BCNetworkConfiguration',
                        'Get-BCStatus',
                        'Get-BitsTransfer',
                        'Get-BpaModel',
                        'Get-BpaResult',
                        'Get-Certificate',
                        'Get-CertificateAutoEnrollmentPolicy',
                        'Get-CertificateEnrollmentPolicyServer',
                        'Get-CertificateNotificationTask',
                        'Get-ChildItem',
                        'Get-CimAssociatedInstance',
                        'Get-CimClass',
                        'Get-CimInstance',
                        'Get-CimSession',
                        'Get-CIPolicy',
                        'Get-CIPolicyIdInfo',
                        'Get-CIPolicyInfo',
                        'Get-Clipboard',
                        'Get-ClusteredScheduledTask',
                        'Get-CmsMessage',
                        'Get-Command',
                        'Get-ComputerInfo',
                        'Get-ComputerRestorePoint',
                        'Get-Content',
                        'Get-ControlPanelItem',
                        'Get-Counter',
                        'Get-Credential',
                        'Get-Culture',
                        'Get-DAClientExperienceConfiguration',
                        'Get-DAConnectionStatus',
                        'Get-DAEntryPointTableItem',
                        'Get-DAPolicyChange',
                        'Get-Date',
                        'Get-DedupProperties',
                        'Get-DeliveryOptimizationLog',
                        'Get-DeliveryOptimizationLogAnalysis',
                        'Get-DeliveryOptimizationPerfSnap',
                        'Get-DeliveryOptimizationPerfSnapThisMonth',
                        'Get-DeliveryOptimizationStatus',
                        'Get-Disk',
                        'Get-DiskImage',
                        'Get-DiskSNV',
                        'Get-DiskSNV',
                        'Get-DiskStorageNodeView',
                        'Get-DisplayResolution',
                        'Get-DnsClient',
                        'Get-DnsClientCache',
                        'Get-DnsClientDohServerAddress',
                        'Get-DnsClientGlobalSetting',
                        'Get-DnsClientNrptGlobal',
                        'Get-DnsClientNrptPolicy',
                        'Get-DnsClientNrptRule',
                        'Get-DnsClientServerAddress',
                        'Get-DOConfig',
                        'Get-DODownloadMode',
                        'Get-DOPercentageMaxBackgroundBandwidth',
                        'Get-DOPercentageMaxForegroundBandwidth',
                        'Get-DscConfiguration',
                        'Get-DscConfigurationStatus',
                        'Get-DscLocalConfigurationManager',
                        'Get-DscResource',
                        'Get-Dtc',
                        'Get-DtcAdvancedHostSetting',
                        'Get-DtcAdvancedSetting',
                        'Get-DtcClusterDefault',
                        'Get-DtcClusterTMMapping',
                        'Get-DtcDefault',
                        'Get-DtcLog',
                        'Get-DtcNetworkSetting',
                        'Get-DtcTransaction',
                        'Get-DtcTransactionsStatistics',
                        'Get-DtcTransactionsTraceSession',
                        'Get-DtcTransactionsTraceSetting',
                        'Get-EtwTraceProvider',
                        'Get-EtwTraceSession',
                        'Get-Event',
                        'Get-EventLog',
                        'Get-EventSubscriber',
                        'Get-ExecutionPolicy',
                        'Get-FileHash',
                        'Get-FileIntegrity',
                        'Get-FileShare',
                        'Get-FileShareAccessControlEntry',
                        'Get-FileStorageTier',
                        'Get-FormatData',
                        'Get-Help',
                        'Get-History',
                        'Get-Host',
                        'Get-HotFix',
                        'Get-InitiatorId',
                        'Get-InitiatorPort',
                        'Get-InstalledModule',
                        'Get-InstalledScript',
                        'Get-IscsiConnection',
                        'Get-IscsiServerTarget',
                        'Get-IscsiSession',
                        'Get-IscsiTarget',
                        'Get-IscsiTargetPortal',
                        'Get-IscsiTargetServerSetting',
                        'Get-IscsiVirtualDisk',
                        'Get-IscsiVirtualDiskSnapshot',
                        'Get-IseSnippet',
                        'Get-Item',
                        'Get-ItemProperty',
                        'Get-ItemPropertyValue',
                        'Get-Job',
                        'Get-JobTrigger',
                        'Get-KdsConfiguration',
                        'Get-KdsRootKey',
                        'Get-LocalGroup',
                        'Get-LocalGroupMember',
                        'Get-LocalUser',
                        'Get-Location',
                        'Get-LogProperties',
                        'Get-MaskingSet',
                        'Get-Member',
                        'Get-MMAgent',
                        'Get-MockDynamicParameters',
                        'Get-Module',
                        'Get-MpComputerStatus',
                        'Get-MpComputerStatus',
                        'Get-MpPerformanceReport',
                        'Get-MpPreference',
                        'Get-MpPreference',
                        'Get-MpThreat',
                        'Get-MpThreat',
                        'Get-MpThreatCatalog',
                        'Get-MpThreatCatalog',
                        'Get-MpThreatDetection',
                        'Get-MpThreatDetection',
                        'Get-NCSIPolicyConfiguration',
                        'Get-Net6to4Configuration',
                        'Get-NetAdapter',
                        'Get-NetAdapterAdvancedProperty',
                        'Get-NetAdapterBinding',
                        'Get-NetAdapterChecksumOffload',
                        'Get-NetAdapterDataPathConfiguration',
                        'Get-NetAdapterEncapsulatedPacketTaskOffload',
                        'Get-NetAdapterHardwareInfo',
                        'Get-NetAdapterIPsecOffload',
                        'Get-NetAdapterLso',
                        'Get-NetAdapterPacketDirect',
                        'Get-NetAdapterPowerManagement',
                        'Get-NetAdapterQos',
                        'Get-NetAdapterRdma',
                        'Get-NetAdapterRsc',
                        'Get-NetAdapterRss',
                        'Get-NetAdapterSriov',
                        'Get-NetAdapterSriovVf',
                        'Get-NetAdapterStatistics',
                        'Get-NetAdapterUso',
                        'Get-NetAdapterVmq',
                        'Get-NetAdapterVmqQueue',
                        'Get-NetAdapterVPort',
                        'Get-NetCompartment',
                        'Get-NetConnectionProfile',
                        'Get-NetDnsTransitionConfiguration',
                        'Get-NetDnsTransitionMonitoring',
                        'Get-NetEventNetworkAdapter',
                        'Get-NetEventPacketCaptureProvider',
                        'Get-NetEventProvider',
                        'Get-NetEventSession',
                        'Get-NetEventVFPProvider',
                        'Get-NetEventVmNetworkAdapter',
                        'Get-NetEventVmSwitch',
                        'Get-NetEventVmSwitchProvider',
                        'Get-NetEventWFPCaptureProvider',
                        'Get-NetFirewallAddressFilter',
                        'Get-NetFirewallApplicationFilter',
                        'Get-NetFirewallDynamicKeywordAddress',
                        'Get-NetFirewallInterfaceFilter',
                        'Get-NetFirewallInterfaceTypeFilter',
                        'Get-NetFirewallPortFilter',
                        'Get-NetFirewallProfile',
                        'Get-NetFirewallRule',
                        'Get-NetFirewallSecurityFilter',
                        'Get-NetFirewallServiceFilter',
                        'Get-NetFirewallSetting',
                        'Get-NetIPAddress',
                        'Get-NetIPConfiguration',
                        'Get-NetIPHttpsConfiguration',
                        'Get-NetIPHttpsState',
                        'Get-NetIPInterface',
                        'Get-NetIPsecDospSetting',
                        'Get-NetIPsecMainModeCryptoSet',
                        'Get-NetIPsecMainModeRule',
                        'Get-NetIPsecMainModeSA',
                        'Get-NetIPsecPhase1AuthSet',
                        'Get-NetIPsecPhase2AuthSet',
                        'Get-NetIPsecQuickModeCryptoSet',
                        'Get-NetIPsecQuickModeSA',
                        'Get-NetIPsecRule',
                        'Get-NetIPv4Protocol',
                        'Get-NetIPv6Protocol',
                        'Get-NetIsatapConfiguration',
                        'Get-NetLbfoTeam',
                        'Get-NetLbfoTeamMember',
                        'Get-NetLbfoTeamNic',
                        'Get-NetNat',
                        'Get-NetNatExternalAddress',
                        'Get-NetNatGlobal',
                        'Get-NetNatSession',
                        'Get-NetNatStaticMapping',
                        'Get-NetNatTransitionConfiguration',
                        'Get-NetNatTransitionMonitoring',
                        'Get-NetNeighbor',
                        'Get-NetOffloadGlobalSetting',
                        'Get-NetPrefixPolicy',
                        'Get-NetQosPolicy',
                        'Get-NetRoute',
                        'Get-NetSwitchTeam',
                        'Get-NetSwitchTeamMember',
                        'Get-NetTCPConnection',
                        'Get-NetTCPSetting',
                        'Get-NetTeredoConfiguration',
                        'Get-NetTeredoState',
                        'Get-NetTransportFilter',
                        'Get-NetUDPEndpoint',
                        'Get-NetUDPSetting',
                        'Get-NetView',
                        'Get-NetworkSwitchEthernetPort',
                        'Get-NetworkSwitchFeature',
                        'Get-NetworkSwitchGlobalData',
                        'Get-NetworkSwitchVlan',
                        'Get-NfsClientConfiguration',
                        'Get-NfsClientgroup',
                        'Get-NfsClientLock',
                        'Get-NfsMappedIdentity',
                        'Get-NfsMappingStore',
                        'Get-NfsMountedClient',
                        'Get-NfsNetgroup',
                        'Get-NfsNetgroupStore',
                        'Get-NfsOpenFile',
                        'Get-NfsServerConfiguration',
                        'Get-NfsSession',
                        'Get-NfsShare',
                        'Get-NfsSharePermission',
                        'Get-NfsStatistics',
                        'Get-NonRemovableAppsPolicy',
                        'Get-OdbcDriver',
                        'Get-OdbcDsn',
                        'Get-OdbcPerfCounter',
                        'Get-OffloadDataTransferSetting',
                        'Get-OperationValidation',
                        'Get-OsConfigurationDocument',
                        'Get-OsConfigurationDocumentContent',
                        'Get-OsConfigurationDocumentResult',
                        'Get-Package',
                        'Get-PackageProvider',
                        'Get-PackageSource',
                        'Get-Partition',
                        'Get-PartitionSupportedSize',
                        'Get-PcsvDevice',
                        'Get-PcsvDeviceLog',
                        'Get-PfxCertificate',
                        'Get-PfxData',
                        'Get-PhysicalDisk',
                        'Get-PhysicalDiskSNV',
                        'Get-PhysicalDiskSNV',
                        'Get-PhysicalDiskStorageNodeView',
                        'Get-PhysicalExtent',
                        'Get-PhysicalExtentAssociation',
                        'Get-PlatformIdentifier',
                        'Get-PmemDedicatedMemory',
                        'Get-PmemDisk',
                        'Get-PmemPhysicalDevice',
                        'Get-PmemUnusedRegion',
                        'Get-PnpDevice',
                        'Get-PnpDeviceProperty',
                        'Get-PrintConfiguration',
                        'Get-Printer',
                        'Get-PrinterDriver',
                        'Get-PrinterPort',
                        'Get-PrinterProperty',
                        'Get-PrintJob',
                        'Get-Process',
                        'Get-ProcessMitigation',
                        'Get-ProvisionedAppPackage',
                        'Get-ProvisionedAppxPackage',
                        'Get-PSBreakpoint',
                        'Get-PSCallStack',
                        'Get-PSDrive',
                        'Get-PSHostProcessInfo',
                        'Get-PSProvider',
                        'Get-PSReadLineKeyHandler',
                        'Get-PSReadLineOption',
                        'Get-PSRepository',
                        'Get-PSSession',
                        'Get-PSSessionCapability',
                        'Get-PSSessionConfiguration',
                        'Get-PSSnapin',
                        'Get-Random',
                        'Get-RDAvailableApp',
                        'Get-RDCertificate',
                        'Get-RDConnectionBrokerHighAvailability',
                        'Get-RDDeploymentGatewayConfiguration',
                        'Get-RDFileTypeAssociation',
                        'Get-RDLicenseConfiguration',
                        'Get-RDPersonalSessionDesktopAssignment',
                        'Get-RDPersonalVirtualDesktopAssignment',
                        'Get-RDPersonalVirtualDesktopPatchSchedule',
                        'Get-RDRemoteApp',
                        'Get-RDRemoteDesktop',
                        'Get-RDServer',
                        'Get-RDSessionCollection',
                        'Get-RDSessionCollectionConfiguration',
                        'Get-RDSessionHost',
                        'Get-RDUserSession',
                        'Get-RDVirtualDesktop',
                        'Get-RDVirtualDesktopCollection',
                        'Get-RDVirtualDesktopCollectionConfiguration',
                        'Get-RDVirtualDesktopCollectionJobStatus',
                        'Get-RDVirtualDesktopConcurrency',
                        'Get-RDVirtualDesktopIdleCount',
                        'Get-RDVirtualDesktopTemplateExportPath',
                        'Get-RDWorkspace',
                        'Get-ResiliencySetting',
                        'Get-Runspace',
                        'Get-RunspaceDebug',
                        'Get-ScheduledJob',
                        'Get-ScheduledJobOption',
                        'Get-ScheduledTask',
                        'Get-ScheduledTaskInfo',
                        'Get-SConfig',
                        'Get-SecureBootPolicy',
                        'Get-SecureBootUEFI',
                        'Get-Service',
                        'Get-SilComputer',
                        'Get-SilComputerIdentity',
                        'Get-SilData',
                        'Get-SilLogging',
                        'Get-SilSoftware',
                        'Get-SilUalAccess',
                        'Get-SilWindowsUpdate',
                        'Get-SmbBandWidthLimit',
                        'Get-SmbClientConfiguration',
                        'Get-SmbClientNetworkInterface',
                        'Get-SmbConnection',
                        'Get-SmbDelegation',
                        'Get-SmbGlobalMapping',
                        'Get-SmbMapping',
                        'Get-SmbMultichannelConnection',
                        'Get-SmbMultichannelConstraint',
                        'Get-SmbOpenFile',
                        'Get-SmbServerCertificateMapping',
                        'Get-SmbServerCertProps',
                        'Get-SmbServerConfiguration',
                        'Get-SmbServerNetworkInterface',
                        'Get-SmbSession',
                        'Get-SmbShare',
                        'Get-SmbShareAccess',
                        'Get-SmbWitnessClient',
                        'Get-SMCounterSample',
                        'Get-SMPerformanceCollector',
                        'Get-SMServerBpaResult',
                        'Get-SMServerClusterName',
                        'Get-SMServerEvent',
                        'Get-SMServerFeature',
                        'Get-SMServerInventory',
                        'Get-SMServerService',
                        'Get-StartApps',
                        'Get-StorageAdvancedProperty',
                        'Get-StorageBusBinding',
                        'Get-StorageBusCache',
                        'Get-StorageBusClientDevice',
                        'Get-StorageBusDisk',
                        'Get-StorageBusTargetCacheStore',
                        'Get-StorageBusTargetCacheStoresInstance',
                        'Get-StorageBusTargetDevice',
                        'Get-StorageBusTargetDeviceInstance',
                        'Get-StorageChassis',
                        'Get-StorageDataCollection',
                        'Get-StorageDiagnosticInfo',
                        'Get-StorageEnclosure',
                        'Get-StorageEnclosureSNV',
                        'Get-StorageEnclosureSNV',
                        'Get-StorageEnclosureStorageNodeView',
                        'Get-StorageEnclosureVendorData',
                        'Get-StorageExtendedStatus',
                        'Get-StorageFaultDomain',
                        'Get-StorageFileServer',
                        'Get-StorageFirmwareInformation',
                        'Get-StorageHealthAction',
                        'Get-StorageHealthReport',
                        'Get-StorageHealthSetting',
                        'Get-StorageHistory',
                        'Get-StorageJob',
                        'Get-StorageNode',
                        'Get-StoragePool',
                        'Get-StorageProvider',
                        'Get-StorageRack',
                        'Get-StorageReliabilityCounter',
                        'Get-StorageScaleUnit',
                        'Get-StorageSetting',
                        'Get-StorageSite',
                        'Get-StorageSubSystem',
                        'Get-StorageTier',
                        'Get-StorageTierSupportedSize',
                        'Get-SupportedClusterSizes',
                        'Get-SupportedFileSystems',
                        'Get-SystemDriver',
                        'Get-TargetPort',
                        'Get-TargetPortal',
                        'Get-TestDriveItem',
                        'Get-TimeZone',
                        'Get-TlsCipherSuite',
                        'Get-TlsEccCurve',
                        'Get-Tpm',
                        'Get-TpmEndorsementKeyInfo',
                        'Get-TpmSupportedFeature',
                        'Get-TraceSource',
                        'Get-Transaction',
                        'Get-TroubleshootingPack',
                        'Get-TypeData',
                        'Get-Ual',
                        'Get-UalDailyAccess',
                        'Get-UalDailyDeviceAccess',
                        'Get-UalDailyUserAccess',
                        'Get-UalDeviceAccess',
                        'Get-UalDns',
                        'Get-UalHyperV',
                        'Get-UalOverview',
                        'Get-UalServerDevice',
                        'Get-UalServerUser',
                        'Get-UalSystemId',
                        'Get-UalUserAccess',
                        'Get-UevAppxPackage',
                        'Get-UevConfiguration',
                        'Get-UevStatus',
                        'Get-UevTemplate',
                        'Get-UevTemplateProgram',
                        'Get-UICulture',
                        'Get-Unique',
                        'Get-Variable',
                        'Get-Verb',
                        'Get-VirtualDisk',
                        'Get-VirtualDiskSupportedSize',
                        'Get-VMDirectVirtualDisk',
                        'Get-Volume',
                        'Get-VolumeCorruptionCount',
                        'Get-VolumeScrubPolicy',
                        'Get-VpnConnection',
                        'Get-VpnConnectionTrigger',
                        'Get-WdacBidTrace',
                        'Get-WheaMemoryPolicy',
                        'Get-WIMBootEntry',
                        'Get-WinAcceptLanguageFromLanguageListOptOut',
                        'Get-WinCultureFromLanguageListOptOut',
                        'Get-WinDefaultInputMethodOverride',
                        'Get-WindowsCapability',
                        'Get-WindowsDeveloperLicense',
                        'Get-WindowsDriver',
                        'Get-WindowsEdition',
                        'Get-WindowsErrorReporting',
                        'Get-WindowsFeature',
                        'Get-WindowsImage',
                        'Get-WindowsImageContent',
                        'Get-WindowsOptionalFeature',
                        'Get-WindowsPackage',
                        'Get-WindowsReservedStorageState',
                        'Get-WindowsSearchSetting',
                        'Get-WindowsUpdateLog',
                        'Get-WinEvent',
                        'Get-WinHomeLocation',
                        'Get-WinhttpProxy',
                        'Get-WinLanguageBarOption',
                        'Get-WinSystemLocale',
                        'Get-WinUILanguageOverride',
                        'Get-WinUserLanguageList',
                        'Get-WmiObject',
                        'Get-WSManCredSSP',
                        'Get-WSManInstance',
                        'Grant-FileShareAccess',
                        'Grant-NfsSharePermission',
                        'Grant-RDOUAccess',
                        'Grant-SmbShareAccess',
                        'Group-Object',
                        'help',
                        'Hide-VirtualDisk',
                        'Import-Alias',
                        'Import-BCCachePackage',
                        'Import-BCSecretKey',
                        'Import-BinaryMiLog',
                        'Import-Certificate',
                        'Import-Clixml',
                        'Import-Counter',
                        'Import-Csv',
                        'Import-IscsiTargetServerConfiguration',
                        'Import-IscsiVirtualDisk',
                        'Import-IseSnippet',
                        'Import-LocalizedData',
                        'Import-Module',
                        'Import-PackageProvider',
                        'Import-PfxCertificate',
                        'Import-PowerShellDataFile',
                        'Import-PSSession',
                        'Import-RDPersonalSessionDesktopAssignment',
                        'Import-RDPersonalVirtualDesktopAssignment',
                        'Import-StartLayout',
                        'Import-TpmOwnerAuth',
                        'Import-UevConfiguration',
                        'Import-WinhttpProxy',
                        'ImportSystemModules',
                        'In',
                        'Initialize-Disk',
                        'Initialize-PmemPhysicalDevice',
                        'Initialize-Tpm',
                        'Initialize-Volume',
                        'Initialize-Volume',
                        'InModuleScope',
                        'Install-Dtc',
                        'Install-Module',
                        'Install-NfsMappingStore',
                        'Install-Package',
                        'Install-PackageProvider',
                        'Install-Script',
                        'Install-WindowsFeature',
                        'Invoke-AsWorkflow',
                        'Invoke-BpaModel',
                        'Invoke-CimMethod',
                        'Invoke-Command',
                        'Invoke-CommandInDesktopPackage',
                        'Invoke-DscResource',
                        'Invoke-Expression',
                        'Invoke-History',
                        'Invoke-Item',
                        'Invoke-Mock',
                        'Invoke-OperationValidation',
                        'Invoke-Pester',
                        'Invoke-RDUserLogoff',
                        'Invoke-RestMethod',
                        'Invoke-SConfig',
                        'Invoke-SConfigLogon',
                        'Invoke-TroubleshootingPack',
                        'Invoke-WebRequest',
                        'Invoke-WmiMethod',
                        'Invoke-WSManAction',
                        'It',
                        'Join-DtcDiagnosticResourceManager',
                        'Join-Path',
                        'Limit-EventLog',
                        'Measure-Command',
                        'Measure-Object',
                        'Merge-CIPolicy',
                        'mkdir',
                        'Mock',
                        'more',
                        'Mount-AppPackageVolume',
                        'Mount-AppvClientConnectionGroup',
                        'Mount-AppvClientPackage',
                        'Mount-AppxVolume',
                        'Mount-DiskImage',
                        'Mount-IscsiVirtualDiskSnapshot',
                        'Mount-WindowsImage',
                        'Move-AppPackage',
                        'Move-AppxPackage',
                        'Move-Item',
                        'Move-ItemProperty',
                        'Move-RDVirtualDesktop',
                        'Move-SmbClient',
                        'Move-SmbWitnessClient',
                        'New-Alias',
                        'New-AppLockerPolicy',
                        'New-AutologgerConfig',
                        'New-CertificateNotificationTask',
                        'New-CimInstance',
                        'New-CimSession',
                        'New-CimSessionOption',
                        'New-CIPolicy',
                        'New-CIPolicyRule',
                        'New-DAEntryPointTableItem',
                        'New-DscChecksum',
                        'New-DtcDiagnosticTransaction',
                        'New-EapConfiguration',
                        'New-EtwTraceSession',
                        'New-Event',
                        'New-EventLog',
                        'New-FileCatalog',
                        'New-FileShare',
                        'New-Fixture',
                        'New-Guid',
                        'New-IscsiServerTarget',
                        'New-IscsiTargetPortal',
                        'New-IscsiVirtualDisk',
                        'New-IseSnippet',
                        'New-Item',
                        'New-ItemProperty',
                        'New-JobTrigger',
                        'New-LocalGroup',
                        'New-LocalUser',
                        'New-MaskingSet',
                        'New-Module',
                        'New-ModuleManifest',
                        'New-MpPerformanceRecording',
                        'New-NetAdapterAdvancedProperty',
                        'New-NetEventSession',
                        'New-NetFirewallDynamicKeywordAddress',
                        'New-NetFirewallRule',
                        'New-NetIPAddress',
                        'New-NetIPHttpsConfiguration',
                        'New-NetIPsecAuthProposal',
                        'New-NetIPsecDospSetting',
                        'New-NetIPsecMainModeCryptoProposal',
                        'New-NetIPsecMainModeCryptoSet',
                        'New-NetIPsecMainModeRule',
                        'New-NetIPsecPhase1AuthSet',
                        'New-NetIPsecPhase2AuthSet',
                        'New-NetIPsecQuickModeCryptoProposal',
                        'New-NetIPsecQuickModeCryptoSet',
                        'New-NetIPsecRule',
                        'New-NetLbfoTeam',
                        'New-NetNat',
                        'New-NetNatTransitionConfiguration',
                        'New-NetNeighbor',
                        'New-NetQosPolicy',
                        'New-NetRoute',
                        'New-NetSwitchTeam',
                        'New-NetTransportFilter',
                        'New-NetworkSwitchVlan',
                        'New-NfsClientgroup',
                        'New-NfsMappedIdentity',
                        'New-NfsNetgroup',
                        'New-NfsShare',
                        'New-Object',
                        'New-Partition',
                        'New-PesterOption',
                        'New-PmemDedicatedMemory',
                        'New-PmemDisk',
                        'New-PSDrive',
                        'New-PSRoleCapabilityFile',
                        'New-PSSession',
                        'New-PSSessionConfigurationFile',
                        'New-PSSessionOption',
                        'New-PSTransportOption',
                        'New-PSWorkflowExecutionOption',
                        'New-PSWorkflowSession',
                        'New-RDCertificate',
                        'New-RDPersonalVirtualDesktopPatchSchedule',
                        'New-RDRemoteApp',
                        'New-RDSessionCollection',
                        'New-RDSessionDeployment',
                        'New-RDVirtualDesktopCollection',
                        'New-RDVirtualDesktopDeployment',
                        'New-ScheduledJobOption',
                        'New-ScheduledTask',
                        'New-ScheduledTaskAction',
                        'New-ScheduledTaskPrincipal',
                        'New-ScheduledTaskSettingsSet',
                        'New-ScheduledTaskTrigger',
                        'New-ScriptFileInfo',
                        'New-SelfSignedCertificate',
                        'New-Service',
                        'New-SmbGlobalMapping',
                        'New-SmbMapping',
                        'New-SmbMultichannelConstraint',
                        'New-SmbServerCertificateMapping',
                        'New-SmbShare',
                        'New-StorageBusBinding',
                        'New-StorageBusCacheStore',
                        'New-StorageFileServer',
                        'New-StoragePool',
                        'New-StorageSubsystemVirtualDisk',
                        'New-StorageTier',
                        'New-TemporaryFile',
                        'New-TimeSpan',
                        'New-TlsSessionTicketKey',
                        'New-Variable',
                        'New-VirtualDisk',
                        'New-VirtualDiskClone',
                        'New-VirtualDiskSnapshot',
                        'New-Volume',
                        'New-VpnServerAddress',
                        'New-WebServiceProxy',
                        'New-WindowsCustomImage',
                        'New-WindowsImage',
                        'New-WinEvent',
                        'New-WinUserLanguageList',
                        'New-WSManInstance',
                        'New-WSManSessionOption',
                        'Open-NetGPO',
                        'Optimize-AppProvisionedPackages',
                        'Optimize-AppxProvisionedPackages',
                        'Optimize-ProvisionedAppPackages',
                        'Optimize-ProvisionedAppxPackages',
                        'Optimize-StoragePool',
                        'Optimize-Volume',
                        'Optimize-WindowsImage',
                        'oss',
                        'Out-Default',
                        'Out-File',
                        'Out-GridView',
                        'Out-Host',
                        'Out-Null',
                        'Out-Printer',
                        'Out-String',
                        'Pause',
                        'Pop-Location',
                        'prompt',
                        'Protect-CmsMessage',
                        'PSConsoleHostReadLine',
                        'Publish-AppvClientPackage',
                        'Publish-BCFileContent',
                        'Publish-BCWebContent',
                        'Publish-DscConfiguration',
                        'Publish-Module',
                        'Publish-Script',
                        'Publish-SilData',
                        'Push-Location',
                        'Read-Host',
                        'Read-PrinterNfcTag',
                        'Receive-DtcDiagnosticTransaction',
                        'Receive-Job',
                        'Receive-PSSession',
                        'Register-ArgumentCompleter',
                        'Register-CimIndicationEvent',
                        'Register-ClusteredScheduledTask',
                        'Register-DnsClient',
                        'Register-EngineEvent',
                        'Register-IscsiSession',
                        'Register-ObjectEvent',
                        'Register-PackageSource',
                        'Register-PSRepository',
                        'Register-PSSessionConfiguration',
                        'Register-ScheduledJob',
                        'Register-ScheduledTask',
                        'Register-StorageSubsystem',
                        'Register-UevTemplate',
                        'Register-WmiEvent',
                        'Remove-AppPackage',
                        'Remove-AppPackageVolume',
                        'Remove-AppProvisionedPackage',
                        'Remove-AppvClientConnectionGroup',
                        'Remove-AppvClientPackage',
                        'Remove-AppvPublishingServer',
                        'Remove-AppxPackage',
                        'Remove-AppxProvisionedPackage',
                        'Remove-AppxVolume',
                        'Remove-AutologgerConfig',
                        'Remove-BCDataCacheExtension',
                        'Remove-BitsTransfer',
                        'Remove-CertificateEnrollmentPolicyServer',
                        'Remove-CertificateNotificationTask',
                        'Remove-CimInstance',
                        'Remove-CimSession',
                        'Remove-CIPolicyRule',
                        'Remove-Computer',
                        'Remove-DAEntryPointTableItem',
                        'Remove-DnsClientDohServerAddress',
                        'Remove-DnsClientNrptRule',
                        'Remove-DscConfigurationDocument',
                        'Remove-DtcClusterTMMapping',
                        'Remove-EtwTraceProvider',
                        'Remove-EtwTraceSession',
                        'Remove-Event',
                        'Remove-EventLog',
                        'Remove-FileShare',
                        'Remove-InitiatorId',
                        'Remove-InitiatorIdFromMaskingSet',
                        'Remove-IscsiServerTarget',
                        'Remove-IscsiTargetPortal',
                        'Remove-IscsiVirtualDisk',
                        'Remove-IscsiVirtualDiskSnapshot',
                        'Remove-IscsiVirtualDiskTargetMapping',
                        'Remove-Item',
                        'Remove-ItemProperty',
                        'Remove-Job',
                        'Remove-JobTrigger',
                        'Remove-LocalGroup',
                        'Remove-LocalGroupMember',
                        'Remove-LocalUser',
                        'Remove-MaskingSet',
                        'Remove-Module',
                        'Remove-MpPreference',
                        'Remove-MpPreference',
                        'Remove-MpThreat',
                        'Remove-MpThreat',
                        'Remove-NetAdapterAdvancedProperty',
                        'Remove-NetEventNetworkAdapter',
                        'Remove-NetEventPacketCaptureProvider',
                        'Remove-NetEventProvider',
                        'Remove-NetEventSession',
                        'Remove-NetEventVFPProvider',
                        'Remove-NetEventVmNetworkAdapter',
                        'Remove-NetEventVmSwitch',
                        'Remove-NetEventVmSwitchProvider',
                        'Remove-NetEventWFPCaptureProvider',
                        'Remove-NetFirewallDynamicKeywordAddress',
                        'Remove-NetFirewallRule',
                        'Remove-NetIPAddress',
                        'Remove-NetIPHttpsCertBinding',
                        'Remove-NetIPHttpsConfiguration',
                        'Remove-NetIPsecDospSetting',
                        'Remove-NetIPsecMainModeCryptoSet',
                        'Remove-NetIPsecMainModeRule',
                        'Remove-NetIPsecMainModeSA',
                        'Remove-NetIPsecPhase1AuthSet',
                        'Remove-NetIPsecPhase2AuthSet',
                        'Remove-NetIPsecQuickModeCryptoSet',
                        'Remove-NetIPsecQuickModeSA',
                        'Remove-NetIPsecRule',
                        'Remove-NetLbfoTeam',
                        'Remove-NetLbfoTeamMember',
                        'Remove-NetLbfoTeamNic',
                        'Remove-NetNat',
                        'Remove-NetNatExternalAddress',
                        'Remove-NetNatStaticMapping',
                        'Remove-NetNatTransitionConfiguration',
                        'Remove-NetNeighbor',
                        'Remove-NetQosPolicy',
                        'Remove-NetRoute',
                        'Remove-NetSwitchTeam',
                        'Remove-NetSwitchTeamMember',
                        'Remove-NetTransportFilter',
                        'Remove-NetworkSwitchEthernetPortIPAddress',
                        'Remove-NetworkSwitchVlan',
                        'Remove-NfsClientgroup',
                        'Remove-NfsMappedIdentity',
                        'Remove-NfsNetgroup',
                        'Remove-NfsShare',
                        'Remove-OdbcDsn',
                        'Remove-OsConfigurationDocument',
                        'Remove-Partition',
                        'Remove-PartitionAccessPath',
                        'Remove-PhysicalDisk',
                        'Remove-PmemDedicatedMemory',
                        'Remove-PmemDisk',
                        'Remove-Printer',
                        'Remove-PrinterDriver',
                        'Remove-PrinterPort',
                        'Remove-PrintJob',
                        'Remove-ProvisionedAppPackage',
                        'Remove-ProvisionedAppxPackage',
                        'Remove-PSBreakpoint',
                        'Remove-PSDrive',
                        'Remove-PSReadLineKeyHandler',
                        'Remove-PSSession',
                        'Remove-PSSnapin',
                        'Remove-RDDatabaseConnectionString',
                        'Remove-RDPersonalSessionDesktopAssignment',
                        'Remove-RDPersonalVirtualDesktopAssignment',
                        'Remove-RDPersonalVirtualDesktopPatchSchedule',
                        'Remove-RDRemoteApp',
                        'Remove-RDServer',
                        'Remove-RDSessionCollection',
                        'Remove-RDSessionHost',
                        'Remove-RDVirtualDesktopCollection',
                        'Remove-RDVirtualDesktopFromCollection',
                        'Remove-SmbBandwidthLimit',
                        'Remove-SMBComponent',
                        'Remove-SmbGlobalMapping',
                        'Remove-SmbMapping',
                        'Remove-SmbMultichannelConstraint',
                        'Remove-SmbServerCertificateMapping',
                        'Remove-SmbShare',
                        'Remove-SMServerPerformanceLog',
                        'Remove-StorageBusBinding',
                        'Remove-StorageFaultDomain',
                        'Remove-StorageFileServer',
                        'Remove-StorageHealthIntent',
                        'Remove-StorageHealthSetting',
                        'Remove-StoragePool',
                        'Remove-StorageTier',
                        'Remove-TargetPortFromMaskingSet',
                        'Remove-TypeData',
                        'Remove-Variable',
                        'Remove-VirtualDisk',
                        'Remove-VirtualDiskFromMaskingSet',
                        'Remove-VMDirectVirtualDisk',
                        'Remove-VpnConnection',
                        'Remove-VpnConnectionRoute',
                        'Remove-VpnConnectionTriggerApplication',
                        'Remove-VpnConnectionTriggerDnsConfiguration',
                        'Remove-VpnConnectionTriggerTrustedNetwork',
                        'Remove-WindowsCapability',
                        'Remove-WindowsDriver',
                        'Remove-WindowsFeature',
                        'Remove-WindowsImage',
                        'Remove-WindowsPackage',
                        'Remove-WmiObject',
                        'Remove-WSManInstance',
                        'Rename-Computer',
                        'Rename-DAEntryPointTableItem',
                        'Rename-Item',
                        'Rename-ItemProperty',
                        'Rename-LocalGroup',
                        'Rename-LocalUser',
                        'Rename-MaskingSet',
                        'Rename-NetAdapter',
                        'Rename-NetFirewallRule',
                        'Rename-NetIPHttpsConfiguration',
                        'Rename-NetIPsecMainModeCryptoSet',
                        'Rename-NetIPsecMainModeRule',
                        'Rename-NetIPsecPhase1AuthSet',
                        'Rename-NetIPsecPhase2AuthSet',
                        'Rename-NetIPsecQuickModeCryptoSet',
                        'Rename-NetIPsecRule',
                        'Rename-NetLbfoTeam',
                        'Rename-NetSwitchTeam',
                        'Rename-NfsClientgroup',
                        'Rename-Printer',
                        'Repair-AppvClientConnectionGroup',
                        'Repair-AppvClientPackage',
                        'Repair-FileIntegrity',
                        'Repair-UevTemplateIndex',
                        'Repair-VirtualDisk',
                        'Repair-Volume',
                        'Repair-WindowsImage',
                        'Reset-AppPackage',
                        'Reset-AppxPackage',
                        'Reset-BC',
                        'Reset-ComputerMachinePassword',
                        'Reset-DAClientExperienceConfiguration',
                        'Reset-DAEntryPointTableItem',
                        'Reset-DtcLog',
                        'Reset-NCSIPolicyConfiguration',
                        'Reset-Net6to4Configuration',
                        'Reset-NetAdapterAdvancedProperty',
                        'Reset-NetDnsTransitionConfiguration',
                        'Reset-NetIPHttpsConfiguration',
                        'Reset-NetIsatapConfiguration',
                        'Reset-NetTeredoConfiguration',
                        'Reset-NfsStatistics',
                        'Reset-PhysicalDisk',
                        'Reset-SConfig',
                        'Reset-SmbClientConfiguration',
                        'Reset-SmbServerConfiguration',
                        'Reset-StorageReliabilityCounter',
                        'Reset-WinhttpProxy',
                        'Resize-IscsiVirtualDisk',
                        'Resize-Partition',
                        'Resize-StorageTier',
                        'Resize-VirtualDisk',
                        'Resolve-DnsName',
                        'Resolve-NfsMappedIdentity',
                        'Resolve-Path',
                        'Restart-Computer',
                        'Restart-NetAdapter',
                        'Restart-PcsvDevice',
                        'Restart-PrintJob',
                        'Restart-Service',
                        'Restore-AuditPolicy',
                        'Restore-Computer',
                        'Restore-DscConfiguration',
                        'Restore-IscsiVirtualDisk',
                        'Restore-NetworkSwitchConfiguration',
                        'Restore-SecurityPolicy',
                        'Restore-UevBackup',
                        'Restore-UevUserSetting',
                        'Resume-BitsTransfer',
                        'Resume-Job',
                        'Resume-PrintJob',
                        'Resume-Service',
                        'Resume-StorageBusDisk',
                        'Revoke-FileShareAccess',
                        'Revoke-NfsClientLock',
                        'Revoke-NfsMountedClient',
                        'Revoke-NfsOpenFile',
                        'Revoke-NfsSharePermission',
                        'Revoke-SmbShareAccess',
                        'SafeGetCommand',
                        'Save-EtwTraceSession',
                        'Save-Help',
                        'Save-Module',
                        'Save-NetGPO',
                        'Save-NetworkSwitchConfiguration',
                        'Save-Package',
                        'Save-Script',
                        'Save-StorageDataCollection',
                        'Save-WindowsImage',
                        'Select',
                        'Select-Object',
                        'Select-String',
                        'Select-Xml',
                        'Send-AppvClientReport',
                        'Send-DtcDiagnosticTransaction',
                        'Send-EtwTraceSession',
                        'Send-MailMessage',
                        'Send-RDUserMessage',
                        'Set-Acl',
                        'Set-Alias',
                        'Set-AppBackgroundTaskResourcePolicy',
                        'Set-AppLockerPolicy',
                        'Set-AppPackageDefaultVolume',
                        'Set-AppPackageProvisionedDataFile',
                        'Set-AppvClientConfiguration',
                        'Set-AppvClientMode',
                        'Set-AppvClientPackage',
                        'Set-AppvPublishingServer',
                        'Set-AppxDefaultVolume',
                        'Set-AppXProvisionedDataFile',
                        'Set-AuthenticodeSignature',
                        'Set-AutologgerConfig',
                        'Set-BCAuthentication',
                        'Set-BCCache',
                        'Set-BCDataCacheEntryMaxAge',
                        'Set-BCMinSMBLatency',
                        'Set-BCSecretKey',
                        'Set-BitsTransfer',
                        'Set-BpaResult',
                        'Set-CertificateAutoEnrollmentPolicy',
                        'Set-CimInstance',
                        'Set-CIPolicyIdInfo',
                        'Set-CIPolicySetting',
                        'Set-CIPolicyVersion',
                        'Set-Clipboard',
                        'Set-ClusteredScheduledTask',
                        'Set-Content',
                        'Set-Culture',
                        'Set-DAClientExperienceConfiguration',
                        'Set-DAEntryPointTableItem',
                        'Set-Date',
                        'Set-DeliveryOptimizationStatus',
                        'Set-Disk',
                        'Set-DisplayResolution',
                        'Set-DnsClient',
                        'Set-DnsClientDohServerAddress',
                        'Set-DnsClientGlobalSetting',
                        'Set-DnsClientNrptGlobal',
                        'Set-DnsClientNrptRule',
                        'Set-DnsClientServerAddress',
                        'Set-DODownloadMode',
                        'Set-DOMaxBackgroundBandwidth',
                        'Set-DOMaxForegroundBandwidth',
                        'Set-DOPercentageMaxBackgroundBandwidth',
                        'Set-DOPercentageMaxForegroundBandwidth',
                        'Set-DscLocalConfigurationManager',
                        'Set-DtcAdvancedHostSetting',
                        'Set-DtcAdvancedSetting',
                        'Set-DtcClusterDefault',
                        'Set-DtcClusterTMMapping',
                        'Set-DtcDefault',
                        'Set-DtcLog',
                        'Set-DtcNetworkSetting',
                        'Set-DtcTransaction',
                        'Set-DtcTransactionsTraceSession',
                        'Set-DtcTransactionsTraceSetting',
                        'Set-DynamicParameterVariables',
                        'Set-EtwTraceProvider',
                        'Set-EtwTraceSession',
                        'Set-ExecutionPolicy',
                        'Set-FileIntegrity',
                        'Set-FileShare',
                        'Set-FileStorageTier',
                        'Set-HVCIOptions',
                        'Set-InitiatorPort',
                        'Set-IscsiChapSecret',
                        'Set-IscsiServerTarget',
                        'Set-IscsiTargetServerSetting',
                        'Set-IscsiVirtualDisk',
                        'Set-IscsiVirtualDiskSnapshot',
                        'Set-Item',
                        'Set-ItemProperty',
                        'Set-JobTrigger',
                        'Set-KdsConfiguration',
                        'Set-LocalGroup',
                        'Set-LocalUser',
                        'Set-Location',
                        'Set-LogProperties',
                        'Set-MMAgent',
                        'Set-MpPreference',
                        'Set-MpPreference',
                        'Set-NCSIPolicyConfiguration',
                        'Set-Net6to4Configuration',
                        'Set-NetAdapter',
                        'Set-NetAdapterAdvancedProperty',
                        'Set-NetAdapterBinding',
                        'Set-NetAdapterChecksumOffload',
                        'Set-NetAdapterDataPathConfiguration',
                        'Set-NetAdapterEncapsulatedPacketTaskOffload',
                        'Set-NetAdapterIPsecOffload',
                        'Set-NetAdapterLso',
                        'Set-NetAdapterPacketDirect',
                        'Set-NetAdapterPowerManagement',
                        'Set-NetAdapterQos',
                        'Set-NetAdapterRdma',
                        'Set-NetAdapterRsc',
                        'Set-NetAdapterRss',
                        'Set-NetAdapterSriov',
                        'Set-NetAdapterUso',
                        'Set-NetAdapterVmq',
                        'Set-NetConnectionProfile',
                        'Set-NetDnsTransitionConfiguration',
                        'Set-NetEventPacketCaptureProvider',
                        'Set-NetEventProvider',
                        'Set-NetEventSession',
                        'Set-NetEventVFPProvider',
                        'Set-NetEventVmSwitchProvider',
                        'Set-NetEventWFPCaptureProvider',
                        'Set-NetFirewallAddressFilter',
                        'Set-NetFirewallApplicationFilter',
                        'Set-NetFirewallInterfaceFilter',
                        'Set-NetFirewallInterfaceTypeFilter',
                        'Set-NetFirewallPortFilter',
                        'Set-NetFirewallProfile',
                        'Set-NetFirewallRule',
                        'Set-NetFirewallSecurityFilter',
                        'Set-NetFirewallServiceFilter',
                        'Set-NetFirewallSetting',
                        'Set-NetIPAddress',
                        'Set-NetIPHttpsConfiguration',
                        'Set-NetIPInterface',
                        'Set-NetIPsecDospSetting',
                        'Set-NetIPsecMainModeCryptoSet',
                        'Set-NetIPsecMainModeRule',
                        'Set-NetIPsecPhase1AuthSet',
                        'Set-NetIPsecPhase2AuthSet',
                        'Set-NetIPsecQuickModeCryptoSet',
                        'Set-NetIPsecRule',
                        'Set-NetIPv4Protocol',
                        'Set-NetIPv6Protocol',
                        'Set-NetIsatapConfiguration',
                        'Set-NetLbfoTeam',
                        'Set-NetLbfoTeamMember',
                        'Set-NetLbfoTeamNic',
                        'Set-NetNat',
                        'Set-NetNatGlobal',
                        'Set-NetNatTransitionConfiguration',
                        'Set-NetNeighbor',
                        'Set-NetOffloadGlobalSetting',
                        'Set-NetQosPolicy',
                        'Set-NetRoute',
                        'Set-NetTCPSetting',
                        'Set-NetTeredoConfiguration',
                        'Set-NetUDPSetting',
                        'Set-NetworkSwitchEthernetPortIPAddress',
                        'Set-NetworkSwitchPortMode',
                        'Set-NetworkSwitchPortProperty',
                        'Set-NetworkSwitchVlanProperty',
                        'Set-NfsClientConfiguration',
                        'Set-NfsClientgroup',
                        'Set-NfsMappedIdentity',
                        'Set-NfsMappingStore',
                        'Set-NfsNetgroup',
                        'Set-NfsNetgroupStore',
                        'Set-NfsServerConfiguration',
                        'Set-NfsShare',
                        'Set-NonRemovableAppsPolicy',
                        'Set-OdbcDriver',
                        'Set-OdbcDsn',
                        'Set-OsConfigurationDocument',
                        'Set-PackageSource',
                        'Set-Partition',
                        'Set-PcsvDeviceBootConfiguration',
                        'Set-PcsvDeviceNetworkConfiguration',
                        'Set-PcsvDeviceUserPassword',
                        'Set-PhysicalDisk',
                        'Set-PrintConfiguration',
                        'Set-Printer',
                        'Set-PrinterProperty',
                        'Set-ProcessMitigation',
                        'Set-ProvisionedAppPackageDataFile',
                        'Set-ProvisionedAppXDataFile',
                        'Set-PSBreakpoint',
                        'Set-PSDebug',
                        'Set-PSReadLineKeyHandler',
                        'Set-PSReadLineOption',
                        'Set-PSRepository',
                        'Set-PSSessionConfiguration',
                        'Set-RDActiveManagementServer',
                        'Set-RDCertificate',
                        'Set-RDClientAccessName',
                        'Set-RDConnectionBrokerHighAvailability',
                        'Set-RDDatabaseConnectionString',
                        'Set-RDDeploymentGatewayConfiguration',
                        'Set-RDFileTypeAssociation',
                        'Set-RDLicenseConfiguration',
                        'Set-RDPersonalSessionDesktopAssignment',
                        'Set-RDPersonalVirtualDesktopAssignment',
                        'Set-RDPersonalVirtualDesktopPatchSchedule',
                        'Set-RDRemoteApp',
                        'Set-RDRemoteDesktop',
                        'Set-RDSessionCollectionConfiguration',
                        'Set-RDSessionHost',
                        'Set-RDVirtualDesktopCollectionConfiguration',
                        'Set-RDVirtualDesktopConcurrency',
                        'Set-RDVirtualDesktopIdleCount',
                        'Set-RDVirtualDesktopTemplateExportPath',
                        'Set-RDWorkspace',
                        'Set-ResiliencySetting',
                        'Set-RuleOption',
                        'Set-ScheduledJob',
                        'Set-ScheduledJobOption',
                        'Set-ScheduledTask',
                        'Set-SConfig',
                        'Set-SecureBootUEFI',
                        'Set-Service',
                        'Set-SilLogging',
                        'Set-SmbBandwidthLimit',
                        'Set-SmbClientConfiguration',
                        'Set-SmbPathAcl',
                        'Set-SmbServerCertificateMapping',
                        'Set-SmbServerConfiguration',
                        'Set-SmbShare',
                        'Set-StorageBusCache',
                        'Set-StorageBusProfile',
                        'Set-StorageFileServer',
                        'Set-StorageHealthSetting',
                        'Set-StoragePool',
                        'Set-StorageProvider',
                        'Set-StorageSetting',
                        'Set-StorageSubSystem',
                        'Set-StorageTier',
                        'Set-StrictMode',
                        'Set-TestInconclusive',
                        'Set-TimeZone',
                        'Set-TpmOwnerAuth',
                        'Set-TraceSource',
                        'Set-UevConfiguration',
                        'Set-UevTemplateProfile',
                        'Set-Variable',
                        'Set-VirtualDisk',
                        'Set-Volume',
                        'Set-VolumeScrubPolicy',
                        'Set-VpnConnection',
                        'Set-VpnConnectionIPsecConfiguration',
                        'Set-VpnConnectionProxy',
                        'Set-VpnConnectionTriggerDnsConfiguration',
                        'Set-VpnConnectionTriggerTrustedNetwork',
                        'Set-WheaMemoryPolicy',
                        'Set-WinAcceptLanguageFromLanguageListOptOut',
                        'Set-WinCultureFromLanguageListOptOut',
                        'Set-WinDefaultInputMethodOverride',
                        'Set-WindowsEdition',
                        'Set-WindowsProductKey',
                        'Set-WindowsReservedStorageState',
                        'Set-WindowsSearchSetting',
                        'Set-WinHomeLocation',
                        'Set-WinhttpProxy',
                        'Set-WinLanguageBarOption',
                        'Set-WinSystemLocale',
                        'Set-WinUILanguageOverride',
                        'Set-WinUserLanguageList',
                        'Set-WmiInstance',
                        'Set-WSManInstance',
                        'Set-WSManQuickConfig',
                        'Setup',
                        'Should',
                        'Show-Command',
                        'Show-ControlPanelItem',
                        'Show-EventLog',
                        'Show-NetFirewallRule',
                        'Show-NetIPsecRule',
                        'Show-StorageHistory',
                        'Show-VirtualDisk',
                        'Show-WindowsDeveloperLicenseRegistration',
                        'Sort-Object',
                        'Split-Path',
                        'Split-WindowsImage',
                        'Start-AppBackgroundTask',
                        'Start-AppvVirtualProcess',
                        'Start-AutologgerConfig',
                        'Start-BitsTransfer',
                        'Start-DscConfiguration',
                        'Start-Dtc',
                        'Start-DtcDiagnosticResourceManager',
                        'Start-DtcTransactionsTraceSession',
                        'Start-EtwTraceSession',
                        'Start-Job',
                        'Start-MpRollback',
                        'Start-MpScan',
                        'Start-MpScan',
                        'Start-MpWDOScan',
                        'Start-MpWDOScan',
                        'Start-NetEventSession',
                        'Start-OSUninstall',
                        'Start-PcsvDevice',
                        'Start-Process',
                        'Start-ScheduledTask',
                        'Start-Service',
                        'Start-SilLogging',
                        'Start-Sleep',
                        'Start-SMPerformanceCollector',
                        'Start-StorageDiagnosticLog',
                        'Start-Trace',
                        'Start-Transaction',
                        'Start-Transcript',
                        'Stop-AppvClientConnectionGroup',
                        'Stop-AppvClientPackage',
                        'Stop-Computer',
                        'Stop-DscConfiguration',
                        'Stop-Dtc',
                        'Stop-DtcDiagnosticResourceManager',
                        'Stop-DtcTransactionsTraceSession',
                        'Stop-EtwTraceSession',
                        'Stop-IscsiVirtualDiskOperation',
                        'Stop-Job',
                        'Stop-NetEventSession',
                        'Stop-PcsvDevice',
                        'Stop-Process',
                        'Stop-RDVirtualDesktopCollectionJob',
                        'Stop-ScheduledTask',
                        'Stop-Service',
                        'Stop-SilLogging',
                        'Stop-SMPerformanceCollector',
                        'Stop-StorageDiagnosticLog',
                        'Stop-StorageJob',
                        'Stop-Trace',
                        'Stop-Transcript',
                        'Suspend-BitsTransfer',
                        'Suspend-Job',
                        'Suspend-PrintJob',
                        'Suspend-Service',
                        'Suspend-StorageBusDisk',
                        'Switch-Certificate',
                        'Sync-AppvPublishingServer',
                        'Sync-NetIPsecRule',
                        'TabExpansion2',
                        'Tee-Object',
                        'Test-AppLockerPolicy',
                        'Test-Certificate',
                        'Test-ComputerSecureChannel',
                        'Test-Connection',
                        'Test-DscConfiguration',
                        'Test-Dtc',
                        'Test-FileCatalog',
                        'Test-KdsRootKey',
                        'Test-ModuleManifest',
                        'Test-NetConnection',
                        'Test-NfsMappedIdentity',
                        'Test-NfsMappingStore',
                        'Test-Path',
                        'Test-PSSessionConfigurationFile',
                        'Test-RDOUAccess',
                        'Test-RDVirtualDesktopADMachineAccountReuse',
                        'Test-ScriptFileInfo',
                        'Test-UevTemplate',
                        'Test-WSMan',
                        'Trace-Command',
                        'Unblock-File',
                        'Unblock-FileShareAccess',
                        'Unblock-SmbShareAccess',
                        'Unblock-Tpm',
                        'Undo-DtcDiagnosticTransaction',
                        'Undo-Transaction',
                        'Uninstall-Dtc',
                        'Uninstall-Module',
                        'Uninstall-Package',
                        'Uninstall-Script',
                        'Uninstall-WindowsFeature',
                        'Unprotect-CmsMessage',
                        'Unpublish-AppvClientPackage',
                        'Unregister-AppBackgroundTask',
                        'Unregister-ClusteredScheduledTask',
                        'Unregister-Event',
                        'Unregister-IscsiSession',
                        'Unregister-PackageSource',
                        'Unregister-PSRepository',
                        'Unregister-PSSessionConfiguration',
                        'Unregister-ScheduledJob',
                        'Unregister-ScheduledTask',
                        'Unregister-StorageSubsystem',
                        'Unregister-UevTemplate',
                        'Unregister-WindowsDeveloperLicense',
                        'Update-AutologgerConfig',
                        'Update-Disk',
                        'Update-DscConfiguration',
                        'Update-DscConfiguration',
                        'Update-EtwTraceSession',
                        'Update-FormatData',
                        'Update-Help',
                        'Update-HostStorageCache',
                        'Update-IscsiTarget',
                        'Update-IscsiTargetPortal',
                        'Update-List',
                        'Update-Module',
                        'Update-ModuleManifest',
                        'Update-MpSignature',
                        'Update-MpSignature',
                        'Update-NetFirewallDynamicKeywordAddress',
                        'Update-NetIPsecRule',
                        'Update-RDVirtualDesktopCollection',
                        'Update-Script',
                        'Update-ScriptFileInfo',
                        'Update-SmbMultichannelConnection',
                        'Update-StorageBusCache',
                        'Update-StorageFirmware',
                        'Update-StoragePool',
                        'Update-StorageProviderCache',
                        'Update-TypeData',
                        'Update-UevTemplate',
                        'Update-WIMBootEntry',
                        'Use-Transaction',
                        'Use-WindowsUnattend',
                        'Wait-Debugger',
                        'Wait-Event',
                        'Wait-Job',
                        'Wait-Process',
                        'Where-Object',
                        'Write-Debug',
                        'Write-DtcTransactionsTraceSession',
                        'Write-Error',
                        'Write-EventLog',
                        'Write-FileSystemCache',
                        'Write-FileSystemCache',
                        'Write-Host',
                        'Write-Information',
                        'Write-Output',
                        'Write-PrinterNfcTag',
                        'Write-Progress',
                        'Write-Verbose',
                        'Write-VolumeCache',
                        'Write-Warning'
                    ]


class PS_command(object):

    def __init__(self, p_cmd:l_cmdlet_name, **kwargs):
        self.__cmd__ = ''
        self.add_cmdlet(p_cmd, **kwargs)

    def add_cmdlet(self, p_cmd, **kwargs):

        if not self.__cmd__:
            self.__cmd__ += p_cmd
        elif self.__cmd__:
            self.__cmd__ += ' | ' + p_cmd

        for key, value in kwargs.items():

            self.__cmd__ += ' -'+key

            if type(value) == list:
                for index, value2 in enumerate(value):

                    if '$_.' in value2:
                        value2 = '$_."' + value2.replace('$_.', '') + '"'
                    else:
                        value2 = '"' + value2 + '"'

                    if index == 0:
                        self.__cmd__ += ' '+value2
                    elif not index == 0:
                        self.__cmd__ += ', '+value2

            elif type(value) == str:
                if '$_.' in value:
                    value = '$_."' + value.replace('$_.', '') + '"'
                else:
                    value = '"' + value + '"'

                self.__cmd__ += ' '+value

    def pipe(self, p_cmd: l_cmdlet_name, **kwargs):
        self.add_cmdlet(p_cmd, **kwargs)
        return self

    def execute(self, p_depth=1):
        r_value: list = []
        t_command = self.__cmd__ + ' | ConvertTo-Json -Depth ' + str(p_depth) + ' -WarningAction SilentlyContinue'
        proccess = run(["powershell", "-Command", t_command], shell=True, stdout=PIPE, stderr=PIPE, encoding='ISO-8859-1')
        stdout = proccess.stdout
        stderr = proccess.stderr
        try:
            if stdout:
                t_value = json.loads(stdout)
                if not isinstance(t_value, list):
                    r_value.append(t_value)
                else:
                    r_value = t_value
                return Return_value(True, r_value)
            else:
                raise Exception(stderr)
        except Exception as error:
            return Return_value(False, error)